#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <memory.h>

#include "stdcode.h"
#include "files.h"
#include "os.h"
#include "mystring.h"


/****************************************************************************
*
*  Function:    FIL_Prepend
*  Description: Add a line at the top of a file
*
***************************************************************************/
t_RetCode FIL_Prepend( char* Filename_PC, char* Line_PC )
{
    FILE*  InFile_PS;
    FILE*  OutFile_PS;
    int	   Size_I;
    char   TmpStr_AC[256];
    t_Bool More_B;

    t_FileInfo	Info_S;

    sprintf( TmpStr_AC, "%s.new", Filename_PC );
    OutFile_PS = fopen( TmpStr_AC, "w" );
    if ( !OutFile_PS ) {
	FplErr_I = FPLERR_NO_FILE;
	fprintf(stderr, "Can't create '%s'. %s\n", 
		TmpStr_AC, strerror(errno) );
	return OK;
    }

    fprintf( OutFile_PS, "%s", Line_PC );

    CALL(OS_FileInfo(Filename_PC,&Info_S));

    if (!Info_S.Missing_B){
#if 1
	Size_I = 4096;
	Line_PC = (char*) malloc( Size_I );
	if ( NOT Line_PC )
	    RET_ERR( "Out of memory!", Size_I );
	
	InFile_PS = fopen( Filename_PC, "r" );
	if ( !InFile_PS ) {
	    FplErr_I = FPLERR_NO_FILE;
	    fprintf(stderr, "Can't open '%s'. %s\n",
		    Filename_PC, strerror(errno) );
	    return OK;
	}

	for ( STR_ReadLine( InFile_PS, &Line_PC, &Size_I, &More_B );
	     More_B;
	     STR_ReadLine( InFile_PS, &Line_PC, &Size_I, &More_B ) ) {
	    fprintf( OutFile_PS, "%s", Line_PC );
	}
#else
	Size_I = Info_S.Size_I;
	if (Size_I ){
	    Buffer_P = (void*) malloc( Size_I );
	    if(!Buffer_P)
		RET_ERR("Out of memory!",Size_I);

	    fread(Buffer_P,Size_I,1,InFile_PS);
	    fclose(InFile_PS);
	    fwrite(Buffer_P,Size_I,1,OutFile_PS);
	    free(Buffer_P);
	}
#endif
	fclose( InFile_PS );
    }
    fclose( OutFile_PS );

    /* replace the old file with the new */
    if(remove( Filename_PC ))
	RET_ERR("Failed removing .Files!",errno);
    if(rename( TmpStr_AC, Filename_PC ))
	RET_ERR("Failed renaming .Files.new => .Files!",errno);

    return OK;
}
