#ifndef __OS_H__
#define __OS_H__

#include <time.h>
#include "stdcode.h"
#include "fplerr.h"

/****************************************************************************
*
*  Global Defines
*
***************************************************************************/
 
typedef struct {
    uchar  Millenium_I;
    uchar  Year_I;
    uchar  Month_I;
    uchar  DayOfMonth_I;
    uchar  Hour_I;
    uchar  Minute_I;
    uchar  Second_I;
    time_t Time_I;
} t_FileTime;

typedef struct {
    t_FileTime	Time_S;
    long   	Size_I;
    uint   	Missing_B : 1;
} t_FileInfo;

/****************************************************************************
*
*  Global Functions
*
***************************************************************************/

int		OS_ReadKey		( void );
int		OS_KbdHit		( void );
t_RetCode	OS_Sleep		( int );
t_RetCode	OS_Milliseconds		( int* );
t_RetCode 	OS_FileInfo		( uchar*, t_FileInfo* );
t_RetCode 	OS_FindFirst		( char*, char*, char* );
t_RetCode       OS_FileSize		( int, unsigned long* );

#endif /* __OS_H__ */
